/*========================================================================*/
/* gcwrit - Menjanje sadrzaja globalne COMMON zone.                       */
/*========================================================================*/
#include "gcdata.h"           /* Deklaracije korisnickih podataka.        */
#include "lamport.h"          /* Prototipovi funkc. za Laport-ov alg.     */
#include <lib$routines.h>     /* Prototipovi LIB$ funkcija.               */
#include <stdio.h>            /* Prototipovi funkcija za standardni U/I.  */
/*------------------------------------------------------------------------*/
main () {
  int i, k=0; const double radi = 0.5;
  printf ("\n*** Demo program GCWRIT ***\n\n");
  for (i=0; i<500; i++) {
    lam_wait ();              /* Cekanje dozvole za ul. u krit. sekc. /*??*/

    n++;                      /* Pristup globalnoj COMMON zoni.       /****/
    printf ("%4d", n);                                                /****/
    if (++k % 10 == 0) putchar ('\n');                                /****/

    lam_signal ();            /* Signal izlazka iz kriticne sekcije.  /*!!*/

    lib$wait (&radi);         /* Boravak u nekriticnoj sekciji.       /*  */
  }
} /*======================================================================*/
