/*========================================================================*/
/* lamport.h - Deklaracije globalnih podataka i funkcija za Lamport-ov alg*/
/*========================================================================*/
#define MXPROC 130       /* Najveci broj procesa, usaglasen sa parametrom */
                         /* MAXPROCESSCNT operativnog sistema VAX-VMS.    */
/*------------------------------------------------------------------------*/
#define CEKA_BIRANJE 0.5    /* Vreme cekanja dok drugi bira broj.         */
#define CEKA_IZLAZAK 2.0    /* Vreme cekanja dok je drugi u krit. sekc.   */
/*------------------------------------------------------------------------*/
extern volatile int choos[],       /* Indikatori proces-bira-broj.        */
                    numb [];       /* Brojevi dodeljeni procesima.        */
/*------------------------------------------------------------------------*/
void lam_wait (void);              /* Ulazak u kriticnu sekciju.          */
void lam_signal (void);            /* Izlazak iz kriticne sekcije.        */
/*========================================================================*/
