/* sanprimi.c - Primanje poruke.                                    */

#include "sanduk.h"
#include "sistem.h"
#include "proces.h"
#include <stdlib.h>

void sis_primi_poruku (Sanduk *sanduk, void *sadrzaj, int *duzina) {
  sis_sanduk = sanduk;  sis_pokaz = sadrzaj;
  sis_sifra  = SIS_PRIMI_PORUKU;  poziv_os ();
  *duzina = sis_ceo;
}

void primi_poruku (void) {
  Sanduk *sanduk = sis_sanduk; char *sadrzaj=sis_pokaz;
  int duzina, i; Poruka *poruka;
  if (sanduk->stanje == SAND_PORUKA) {  /* Isporuka poruke procesu. */
    poruka = (Poruka *) sanduk->prvi;
    sanduk->prvi = poruka->sledeci; poruka->sledeci = 0;
    if (! sanduk->prvi)
      { sanduk->zadnji = 0;  sanduk->stanje = SAND_PRAZAN; }
  } else {                              /* Stavljanje procesa u red.*/
    if (sanduk->stanje == SAND_PRAZAN) {
      sanduk->prvi = proc_radi; sanduk->stanje = SAND_PROCES;
    } else ((Pcb *) sanduk->zadnji)->sledeci = proc_radi;
    sanduk->zadnji = proc_radi;
    proc_radi->stanje = PROC_BLOKIRAN;
    sis_sifra = SIS_DODELI_PROCESOR;  poziv_os ();
    poruka = proc_radi->pokaz;
  }
  sis_ceo = duzina = poruka->duzina;    /* Prenos sadrzaja poruke.  */
  for (i=0; i<duzina; i++) sadrzaj[i] = poruka->sadrzaj[i];
  free (poruka->sadrzaj);  free (poruka);
}
