// sistem.cpp - Definicije podataka za usluge OS.

#include "sistem.h"
#include "proces.h"
#include "semafor.h"
#include "sanduk.h"

Sistem::Usluga  Sistem::usluge[] =    // Vektor pokazivaca na usluge OS.
	  { Semafor::wait, Semafor::signal,
	    Sanduk::salji, Sanduk::primi, Sanduk::stanje_,
	    Sanduk::novi,  Sanduk::otvori, Sanduk::zatvori, Sanduk::brisi

	  };

int   Sistem::sifra;                              // Sifra usluge OS.
void *Sistem::par1, *Sistem::par2, *Sistem::par3, // Parametri usluge.
     *Sistem::par4, *Sistem::par5, *Sistem::par6;

void Sistem::poziv_os (int sif, void *p1, void *p2, void *p3,
				void *p4, void *p5, void *p6) {
  sifra = sif;
  par1 = p1; par2 = p2; par3 = p3; par4 = p4; par5 = p5; par6 = p6;
  asm int 32;
}

void interrupt Sistem::poziv_os_int () {
  (*usluge[sifra]) ();
}