// akter.h - Apstraktna klasa za aktere (Akter).

#ifndef __akter__h__
#define __akter__h__
#include "thread.h"
#include "bafer.h"

class Akter: public Thread {
protected:
  int broj, tmin, tmax;
  Bafer *bafer;
public:
  Akter (Bafer *baf, int min, int max) {
    bafer = baf;
    tmin = min; tmax = max;
  };
  virtual void pauza () =0;
  virtual void dalje () =0;
  virtual void kraj  () =0;
};
#endif
