// bafer.h - Klasa za kruzne bafere Bafer.

#ifndef __bafer__h__
#define __bafer__h__
#include "region.h";
#include "semaphor.h"

class Bafer {
  int *niz, kap, duz, ulaz, izlaz;
  Region moze;
  Semaphore prazan, pun;
public:
  Bafer (int k): prazan(k), pun(0) {
    niz = new int [kap = k];
    ulaz = izlaz = duz = 0;
  }
  void stavi (int i) {
    prazan.wait ();
    moze.wait ();
      niz[ulaz++] = i; duz++;
      if (ulaz == kap) ulaz = 0;
    moze.signal ();
    pun.signal ();
  }
  int uzmi () {
    pun.wait ();
    moze.wait ();
      int i = niz[izlaz++]; duz--;
      if (izlaz == kap) izlaz = 0;
    moze.signal ();
    prazan.signal ();
    return i;
  }
  void stanje ();
  void parzni ();
  ~Bafer () { moze.wait (); delete [] niz; /*moze.signal ();*/ }
};
#endif
