// proizv.cpp - Metode klase Proizvodjac.

#include "proizv.h"
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

int Proizvodjac::ukBroj = 0;
void Proizvodjac::run () {
  try {
    printf ("Proizvodjac #%d je spreman za rad\n", broj);
    suspend ();
    int k = broj * 1000;
    while (! terminate()) {
      sleep (tmin + random (tmax-tmin));
      bafer->stavi (++k);
      printf ("Proizvodjac #%d je proizveo predmet %d\n",
              broj, k);
    }
    printf ("Proizvodjac #%d je prestao da radi\n", broj);
  } catch (DWORD g) {
    printf ("Proizvodjac #%d prijavljuje gresku %lx\n", broj, g);
    sleep (2000); ::exit (1);
  }
}
void Proizvodjac::pauza () {
  suspend ();
  printf ("Proizvodjac #%d je zapoceo pauzu\n", broj);
}
void Proizvodjac::dalje () {
  printf ("Proizvodjac #%d je zavrsio pauzu\n", broj);
  resume ();
}
void Proizvodjac::kraj () {
  printf ("Proizvodjac #%d se zavrsava\n", broj);
  kill (); // stop ();
}
Proizvodjac::~Proizvodjac () {
  printf ("Proizvodjac #%d se unistava\n", broj);
  kill (); //  stop ();
}

