// regiont.h - Kriticna oblast za sinhronizaciju procesa (Region).

#ifndef __region__h__
#define __region__h__
#include <wtypes.h>
#include <winbase.h>
#include <string.h>

class Region {
public:
  HANDLE rucka;
public:
  Region (char *_ime=NULL) {
    if ((rucka = CreateMutex(NULL,FALSE,_ime)) == 0) GetLastError();
  }
  BOOL wait (DWORD _vreme=INFINITE) {
    DWORD uspeh = WaitForSingleObject (rucka, _vreme);
    if (uspeh == WAIT_FAILED) throw GetLastError ();
    return uspeh != WAIT_TIMEOUT;
  }
  void signal () { if (! ReleaseMutex(rucka)) throw GetLastError(); }
  ~Region () { if (! CloseHandle (rucka)) throw GetLastError (); }
};
#endif

