;==========================================================================
; vreme.asm - Prikazivanje vremena na ekranu.
;==========================================================================
	.286
;--------------------------------------------------------------------------
cseg	segment	para public 'code'
	assume	cs:cseg, ds:cseg, es:cseg, ss:cseg
	org	100h
;--------------------------------------------------------------------------
vreme	proc
	mov	ax, 251Ch
	mov	dx, offset radi
	int	21h
	mov	ax, 3100h
	mov	dx, (vel+15)/16+16
	int	21h
vreme	endp
;--------------------------------------------------------------------------
radi	proc	far
	sti
	push	ax
	push	bx
	push	cx
	push	dx
	push	ds
	mov	ax, cs
	mov	ds, ax

	mov	ah, 2		; Dohvatanje trenutnog vremena.
	int	1ah
	cmp	dh, sek
	je	kraj
	mov	sek, dh
	mov	min, cl
	mov	sat, ch

	mov	ah, 0fh		; Video rezim.
	int	10h
	sub	ah, 5
	mov	kol, ah
	mov	stra, bh

	mov	ah, 3		; Pozicija pokazivaca.
	int	10h
	mov	poz, dx

	mov	al, sat		; Broj sati.
	sar	al, 4
	call	pisi
	mov	al, sat
	and	al, 15
	call	pisi
	mov	al, ':'-'0'
	call	pisi
	mov	al, min		; Broj minuta.
	sar	al, 4
	call	pisi
	mov	al, min
	and	al, 15
	call	pisi

	mov	ah, 2		; Vracanje pokazivaca u pocetnu poziciju.
	mov	dx, poz
	int	10h

kraj:	pop	ds
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	iret
radi	endp
;--------------------------------------------------------------------------
pisi	proc
	push	bx
	push	cx
	mov	ah, 2		; Pomeranje pokazivaca.
	mov	dh, vrs
	mov	dl, kol
	mov	bh, stra
	int	10h
	inc	kol
	mov	ah, 9		; Prikazivanje znaka.
	add	al, '0'
	mov	bl, 1fh
	mov	cx, 1
	int	10h
	pop	cx
	pop	bx

	ret
pisi	endp
;--------------------------------------------------------------------------
	even
vrs	db	0		; Redni broj vrste.
kol	db	?		; Redni broj kolone.
poz	dw	?		; Zatecena pozicija pokazivaca.
stra	db	?		; Aktivna stranica.
sek	db	-1		; Stari broj sekundi.
min	db	?		; Broj minuta.
sat	db	?		; broj sata.
vel	equ	$-vreme
;--------------------------------------------------------------------------
cseg	ends
;==========================================================================
	end	vreme
