// bafer.cpp - Definicije funkcija za rad sa kruznim baferom.

#include "bafer.h"
#include <stdlib.h>

Bafer::Bafer (int vel) {
  if ((sadrzaj = new int [velicina = vel]) != 0) {
    prazno   = Semafor (velicina);
    puno     = Semafor (0);
    slobodan = Semafor (1);
  }
}

void Bafer::stavi (int vr) {
  prazno  .sis_wait ();      // Ima li praznog mesta?
  slobodan.sis_wait ();      // Da li je pristup dozvoljen?
    *ulaz++ = vr;
    if (ulaz == sadrzaj + velicina) ulaz = sadrzaj;
  slobodan.sis_signal ();    // Pristup je zavrsen.
  puno    .sis_signal ();    // Jedno mesto je popunjeno.
}

int Bafer::uzmi () {
  puno    .sis_wait ();      // Ima li popunjenog mesta?
  slobodan.sis_wait ();      // Da li je pristup dozvoljen?
    int vr = *izlaz++;
    if (izlaz == sadrzaj + velicina) izlaz = sadrzaj;
  slobodan.sis_signal ();    // Pristup je zavrsen.
  prazno  .sis_signal ();    // Jedno mesto je oslobodjeno.
  return vr;
}

Bafer::~Bafer () {
  delete [] sadrzaj;
}