// bafer.h - Deklaracija podataka i funkcija za rad sa kruznim baferom.

#ifndef _bafer_h_
#define _bafer_h_

#include "semafor.h"

class Bafer {                // KRUZNI BAFER:
  int   velicina;            // Velicina bafera.
  int  *sadrzaj;             // Sadrzaj bafera.
  int  *ulaz;                // Pokazivac na mesto ulaza.
  int  *izlaz;               // Pokazivac na mesto izlaza.
  Semafor prazno;            // Broj praznih mesta u baferu.
  Semafor puno;              // Broj popunjenih mesta u baferu.
  Semafor slobodan;          // Pristup baferu je dozvoljen.
public:
  Bafer (int);               // Formiranje praznog bafera.
  void  stavi (int);         // Smestanje podatka u bafer.
  int   uzmi  ();            // Uzimanje podatka iz bafera.
  ~Bafer ();                 // Unistavanje bafera.
} ;

#endif
