/*========================================================================*/
/* lamsign.c - Izlazak iz kriticne sekcije po Lamport-ovom algoritmu.     */
/*========================================================================*/
#include "lamport.h"          /* Strukture podataka za Lamport-ov alg.    */
#include <lib$routines.h>     /* Prototipovi LIB$ funkcija.               */
#include <jpidef.h>           /* Definicije JPI$ konstanti.               */
/*------------------------------------------------------------------------*/
void lam_signal () {
  int i;
  const int jpi_indeks = JPI$_PROC_INDEX; 

  lib$getjpi (&jpi_indeks, 0, 0, &i, 0, 0); /* Indeks procesa (1, 2, ...) */
  numb[i] = 0;
} /*======================================================================*/
