/* sanpravi.c - Formiranje novog sanduka (otvaranje ako vec postoji)*/

#include "sanduk.h"
#include "sistem.h"
#include <stdlib.h>
#include <string.h>

Sanduk *sis_pravi_sanduk (char *ime) {
  sis_pokaz = ime;  sis_sifra = SIS_PRAVI_SANDUK;  poziv_os ();
  return sis_sanduk;
}

void pravi_sanduk (void) {
  char *ime = (char *) sis_pokaz;
  Sanduk *novi = nadji_sanduk (ime);
  if (novi) novi->broj++;
  else {
    novi = malloc (sizeof (Sanduk));
    novi->sledeci   = 0;
    novi->prethodni = sand_zadnji;
    if (sand_zadnji) sand_zadnji->sledeci=novi; else sand_prvi=novi;
    sand_zadnji = novi;
    novi->ime = malloc (strlen(ime) + 1);  strcpy (novi->ime, ime);
    novi->broj = 1;
    novi->stanje = SAND_PRAZAN;
    novi->prvi   = novi->zadnji = 0;
  }
  sis_sanduk = novi;
}
