// sistem.h - Deklaracije podataka i funkcija za usluge OS.

#ifndef _sistem_h_
#define _sistem_h_

class Sistem {
public:
  enum { SEM_WAIT, SEM_SIGNAL,
	 SAND_SALJI, SAND_PRIMI, SAND_STANJE,
	 SAND_NOVI, SAND_OTVORI, SAND_ZATVORI, SAND_BRISI,
       };

static void poziv_os (int sifra, void *p1=0, void *p2=0, void *p3=0,
			  void *p4=0, void *p5=0, void *p6=0);
void interrupt poziv_os_int ();

  static void *par1, *par2, *par3,   // Parametri usluge OS.
	      *par4, *par5, *par6;
private:
  static int sifra;                  // Sifra usluge OS.
  typedef void (*Usluga) (void);     // Pokazivac na uslugu OS.
  static Usluga   usluge[];          // Vektor pokazivaca na usluge OS.

};

#endif
