// bafert.cpp - Problem potrosaca i proizvodjaca.

#include "proizv.h"
#include "potros.h"
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

int main () {
  randomize ();
  printf ("Kapacitet bafera? ");
  int kap; scanf ("%d", &kap);
  printf ("Proizvodjaci (broj, tmin, tmax)? ");
  int proBroj, proTmin, proTmax;
  scanf ("%d%d%d", &proBroj, &proTmin, &proTmax);
  printf ("Potrosaci (broj, tmin, tmax)?    ");
  int potBroj, potTmin, potTmax;
  scanf ("%d%d%d", &potBroj, &potTmin, &potTmax);
  try {
    Bafer baf(kap);
    int ukupno = proBroj + potBroj;
    Akter **akteri = new Akter* [ukupno];
    for (int i=0; i<proBroj;
         akteri[i++] = new Proizvodjac (&baf, proTmin, proTmax));
    for (       ; i<ukupno;
         akteri[i++] = new Potrosac    (&baf, potTmin, potTmax));
    Thread::sleep (100);
    for (i=proBroj; i<ukupno; akteri[i++]->dalje());
    printf ("\nMoguce komande: Dalje, Pauza, Stanje, Kraj\n");
    for (int dalje=1; dalje; ) {
      switch (getch ()) {
        case 'd': case 'D':
          { for (int i=0; i<proBroj; akteri[i++]->dalje()); break; }
        case 'p': case 'P':
          { for (int i=0; i<proBroj; akteri[i++]->pauza()); break; }
        case 'k': case 'K':
          { for (int i=0; i<ukupno;  akteri[i++]->kraj ());
            dalje=0; break; }
        case 's': case 'S':
          { printf ("Satnje bafera: "); baf.stanje ();
            putchar ('\n'); break; }
      }
    }
    for (i=0; i<ukupno; delete akteri[i++]);
    delete [] akteri;
    printf ("Pritisnite bilo koji taster ..."); getch ();
  } catch (DWORD g) { 
    printf ("Glavni program prijavljuje gresku %lx\n", g); getch();
  }
  return 0;
}