// potros.cpp - Metode klase Potrosac.

#include "potros.h"
#include <stdio.h>
#include <stdlib.h>

int Potrosac::ukBroj = 0;
void Potrosac::run () {
  try {
    printf ("Potrosac #%d je spreman za rad\n", broj);
    suspend ();
    while (! terminate()) {
      int k = bafer->uzmi ();
      printf ("Potrosac #%d je uzeo predmet %d\n",
              broj, k);
      sleep (tmin + random (tmax-tmin));
    }
    printf ("Potrosac #%d je prestao da radi\n", broj);
  } catch (DWORD g) {
    printf ("Potrosac #%d prijavljuje gresku %lx\n", broj, g);
    sleep (2000); ::exit (1);
  }
}
void Potrosac::pauza () {
  suspend ();
  printf ("Potrosac #%d je zapoceo pauzu\n", broj);
}
void Potrosac::dalje () {
  printf ("Potrosac #%d je zavrsio pauzu\n", broj);
  resume ();
}
void Potrosac::kraj () {
  printf ("Potrosac #%d se zavrsava\n", broj);
  kill (); //stop ();
}
Potrosac::~Potrosac () {
  printf ("Potrosac #%d se unistava\n", broj);
  kill (); //  stop ();
}

