// proizv.h - Klasa za proizvodjace (Proizvodjac).

#ifndef __proizv__h__
#define __proizv__h__
#include "akter.h"
#include "bafer.h"

class Proizvodjac: public Akter {
  static int ukBroj;
public:
  Proizvodjac (Bafer *baf, int min, int max):
    Akter (baf, min, max) { broj = ++ukBroj; start (); };
  void run ();
  void pauza ();
  void dalje ();
  void kraj ();
  ~Proizvodjac ();
};
#endif
