/* semafor.h - Deklaracije podataka i funkcija za rad sa semaforima */

#ifndef _semafor_h_
#define _semafor_h_

typedef struct pcb Pcb;

typedef struct semafor {           /* SEMAFOR:                      */
          int  vrednost;           /* Vrednost semafora.            */
          Pcb *prvi;               /* Prvi proces koji ceka.        */
          Pcb *zadnji;             /* Zadnji proces koji ceka.      */
        } Semafor;

Semafor semafor (int);             /* Pocetna vrednost semafora.    */
void sis_wait   (Semafor *);       /* Primitiva WAIT.               */
void     wait   (void);
void sis_signal (Semafor *);       /* Primitiva SIGNAL.             */
void     signal (void);

#endif
